---
title: RegExp.prototype.exec()
slug: Web/JavaScript/Reference/Global_Objects/RegExp/exec
tags:
  - JavaScript
  - Method
  - Prototype
  - Reference
  - RegExp
  - Regular Expressions
---
<div>{{JSRef}}</div>

<p><span class="seoSummary">The <strong><code>exec()</code></strong> method executes a search for a match in a specified string. Returns a result array, or {{jsxref("null")}}.</span></p>

<p>JavaScript {{jsxref("RegExp")}} objects are <strong>stateful</strong> when they have the {{jsxref("RegExp.global", "global")}} or {{jsxref("RegExp.sticky", "sticky")}} flags set (e.g. <code>/foo/g</code> or <code>/foo/y</code>). They store a {{jsxref("RegExp.lastIndex", "lastIndex")}} from the previous match. Using this internally, <code>exec()</code> can be used to iterate over multiple matches in a string of text (with capture groups), as opposed to getting just the matching strings with {{jsxref("String.prototype.match()")}}.</p>

<p>A newer function has been proposed to simplify matching multiple parts of a string (with capture groups): {{jsxref("String.prototype.matchAll()")}}.</p>

<p>If you are executing a match to find <code>true</code> or <code>false</code>, use {{jsxref("RegExp.prototype.test()")}} method or {{jsxref("String.prototype.search()")}} instead.</p>

<div>{{EmbedInteractiveExample("pages/js/regexp-prototype-exec.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>regexObj</var>.exec(<var>str</var>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>str</var></code></dt>
 <dd>The string against which to match the regular expression.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>If the match succeeds, the <code>exec()</code> method returns an array (with extra properties <code>index</code> and <code>input</code>; see below) and updates the {{jsxref("RegExp.lastIndex", "lastIndex")}} property of the regular expression object. The returned array has the matched text as the first item, and then one item for each parenthetical capture group of the matched text.</p>

<p>If the match fails, the <code>exec()</code> method returns {{jsxref("null")}}, and sets {{jsxref("RegExp.lastIndex", "lastIndex")}} to <code>0</code>.</p>

<h2 id="Description">Description</h2>

<p>Consider the following example:</p>

<pre class="brush: js notranslate">// Match "quick brown" followed by "jumps", ignoring characters in between
// Remember "brown" and "jumps"
// Ignore case
let re = /quick\s(brown).+?(jumps)/ig;
let result = re.exec('The Quick Brown Fox Jumps Over The Lazy Dog');
</pre>

<p>The following table shows the results for this script:</p>

<table class="fullwidth-table standard-table">
 <thead>
  <tr>
   <th scope="row">Object</th>
   <th scope="col">Property/Index</th>
   <th scope="col">Description</th>
   <th scope="col">Example</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <th colspan="1" rowspan="4" scope="row" style="vertical-align: top;"><code>result</code></th>
   <td><code>[0]</code></td>
   <td>The full string of characters matched</td>
   <td><code>"Quick Brown Fox Jumps"</code></td>
  </tr>
  <tr>
   <td><code>[1], ...[<var>n</var>]</code></td>
   <td>
    <p>The parenthesized substring matches, if any.</p>

    <p>The number of possible parenthesized substrings is unlimited.</p>
   </td>
   <td>
    <p><code>result[1] === "Brown"</code></p>

    <p><code>result[2] === "Jumps"</code></p>
   </td>
  </tr>
  <tr>
   <td><code>index</code></td>
   <td>The 0-based index of the match in the string.</td>
   <td><code>4</code></td>
  </tr>
  <tr>
   <td><code>input</code></td>
   <td>The original string that was matched against.</td>
   <td><code>The Quick Brown Fox Jumps Over The Lazy Dog</code></td>
  </tr>
  <tr>
   <th colspan="1" rowspan="5" scope="row" style="vertical-align: top;"><code>re</code></th>
   <td><code>lastIndex</code></td>
   <td>
    <p>The index at which to start the next match.</p>

    <p>If <code>g</code> is absent, this will always be <code>0</code>.</p>
   </td>
   <td><code>25</code></td>
  </tr>
  <tr>
   <td><code>ignoreCase</code></td>
   <td>Indicates if the <code>i</code> flag was used to ignore case.</td>
   <td><code>true</code></td>
  </tr>
  <tr>
   <td><code>global</code></td>
   <td>Indicates if the <code>g</code> flag was used for a global match.</td>
   <td><code>true</code></td>
  </tr>
  <tr>
   <td><code>multiline</code></td>
   <td>Indicates if the <code>m</code> flag was used to search across multiple lines.</td>
   <td><code>false</code></td>
  </tr>
  <tr>
   <td><code>source</code></td>
   <td>The text of the pattern.</td>
   <td><code>quick\s(brown).+?(jumps)</code></td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<h3 id="Finding_successive_matches">Finding successive matches</h3>

<p>If your regular expression uses the "<code>g</code>" flag, you can use the <code>exec()</code> method multiple times to find successive matches in the same string. When you do so, the search starts at the substring of <code><var>str</var></code> specified by the regular expression's {{jsxref("RegExp.lastIndex", "lastIndex")}} property ({{jsxref("RegExp.prototype.test()", "test()")}} will also advance the {{jsxref("RegExp.lastIndex", "lastIndex")}} property). Note that the {{jsxref("RegExp.lastIndex", "lastIndex")}} property will not be reset when searching a different string, it will start its search at its existing {{jsxref("RegExp.lastIndex", "lastIndex")}} .</p>

<p>For example, assume you have this script:</p>

<pre class="brush: js notranslate">let myRe = /ab*/g;
let str = 'abbcdefabh';
let myArray;
while ((myArray = myRe.exec(str)) !== null) {
  let msg = 'Found ' + myArray[0] + '. ';
  msg += 'Next match starts at ' + myRe.lastIndex;
  console.log(msg);
}
</pre>

<p>This script displays the following text:</p>

<pre class="notranslate">Found abb. Next match starts at 3
Found ab. Next match starts at 9
</pre>

<div class="warning">
<p><strong>Warning:</strong> <strong>Do <em>not</em> place the regular expression literal (or {{jsxref("RegExp")}} constructor) within the <code>while</code> condition! </strong></p>

<p>It will create an infinite loop if there is a match, due to the {{jsxref("RegExp.lastIndex", "lastIndex")}} property being reset upon each iteration.</p>

<p>Also, be sure that the global flag ("<code>g</code>") is set, or it will also cause an infinite loop.</p>
</div>

<h3 id="Using_exec_with_RegExp_literals">Using exec() with RegExp literals</h3>

<p>You can also use <code>exec()</code> without creating a {{jsxref("RegExp")}} object explicitly:</p>

<pre class="brush: js notranslate">let matches = /(hello \S+)/.exec('This is a hello world!');
console.log(matches[1]);
</pre>

<p>This will log a message containing <code>'hello world!'</code>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-regexp.prototype.exec', 'RegExp.exec')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.RegExp.exec")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Regular_Expressions">Regular Expressions</a> chapter in the <a href="/en-US/docs/Web/JavaScript/Guide">JavaScript Guide</a></li>
 <li>{{jsxref("RegExp")}}</li>
</ul>
